% -------------------------------------------------------------------------
% modal definitions 
% -------------------------------------------------------------------------

% declare type for possible worlds
thf( mworld_type , type , ( mworld:$tType ) ).

% declare accessibility relations
thf( mrel_0_type , type , ( mrel_0:mworld>mworld>$o) ).
thf( mrel_1_type , type , ( mrel_1:mworld>mworld>$o) ).

% define accessibility relation properties
thf( mserial_type , type , ( mserial : (mworld>mworld>$o)>$o ) ).
thf( mserial_def , definition , ( mserial = (^ [R:mworld>mworld>$o] : ! [A:mworld] : ? [B:mworld] : (R@A@B)))).

% assign properties to accessibility relations
thf( mrel_0_mserial , axiom , ( mserial @ mrel_0 ) ).
thf( mrel_1_mserial , axiom , ( mserial @ mrel_1 ) ).

% define current-world constant and actuality operator
thf( mcurrentworld_type , type , ( mcurrentworld: mworld ) ).
thf( mactual_type , type , ( mactual: ( ( mworld>$o ) >$o ) ) ).
thf( mactual_def , definition , ( mactual = ( ^ [Phi:(mworld>$o)] : ( Phi @ mcurrentworld ) ) ) ).

% define nullary, unary and binary connectives which are no quantifiers
thf( mimplies_type , type , ( mimplies: (mworld>$o)>(mworld>$o)>mworld>$o) ).
thf( mimplies , definition , ( mimplies = (^ [A:mworld>$o,B:mworld>$o,W:mworld] : ( (A@W) => (B@W) )))).
thf( mnot_type , type , ( mnot: (mworld>$o)>mworld>$o) ).
thf( mnot , definition , ( mnot = (^ [A:mworld>$o,W:mworld] : ~(A@W)))).
thf( mand_type,type , ( mand: (mworld>$o)>(mworld>$o)>mworld>$o) ).
thf( mand , definition , ( mand = (^ [A:mworld>$o,B:mworld>$o,W:mworld] : ( (A@W) & (B@W) )))).
thf( mdia_int_0_type , type , ( mdia_int_0: (mworld>$o)>mworld>$o) ).
thf( mdia_int_0_def , definition , ( mdia_int_0 = (^ [A:mworld>$o,W:mworld] : ? [V:mworld] : ( (mrel_0@W@V) & (A@V) )))).
thf( mdia_int_1_type , type , ( mdia_int_1: (mworld>$o)>mworld>$o) ).
thf( mdia_int_1_def , definition , ( mdia_int_1 = (^ [A:mworld>$o,W:mworld] : ? [V:mworld] : ( (mrel_1@W@V) & (A@V) )))).
thf( mbox_int_0_type , type , ( mbox_int_0: (mworld>$o)>mworld>$o) ).
thf( mbox_int_0_def , definition , ( mbox_int_0 = (^ [A:mworld>$o,W:mworld] : ! [V:mworld] : ( (mrel_0@W@V) => (A@V) )))).
thf( mbox_int_1_type , type , ( mbox_int_1: (mworld>$o)>mworld>$o) ).
thf( mbox_int_1_def , definition , ( mbox_int_1 = (^ [A:mworld>$o,W:mworld] : ! [V:mworld] : ( (mrel_1@W@V) => (A@V) )))).

% define for all quantifiers
thf( mforall_const_type__o__d_i_c_ , type , ( mforall_const__o__d_i_c_ : ( ( ( ($i) ) > ( mworld > $o ) ) > mworld > $o ) ) ).
thf( mforall_const__o__d_i_c_ , definition , ( mforall_const__o__d_i_c_ = ( ^ [A:(($i))>mworld>$o,W:mworld] : ! [X:(($i))] : (A @ X @ W)))).

% -------------------------------------------------------------------------
% transformed problem
% -------------------------------------------------------------------------

% semantics
% propositions
% individual constants
thf(article_6_1_article_9_2_a__const_type,type,(article_6_1_article_9_2_a__const:($i))).
thf(purpose__const_type,type,(purpose__const:($i))).
thf(lodge_complaint__const_type,type,(lodge_complaint__const:($i))).
thf(access_rectification_etc__const_type,type,(access_rectification_etc__const:($i))).
thf(data__const_type,type,(data__const:($i))).
thf(collection_time__const_type,type,(collection_time__const:($i))).
thf(processor_2__const_type,type,(processor_2__const:($i))).
thf(subject__const_type,type,(subject__const:($i))).
thf(article_6_1__const_type,type,(article_6_1__const:($i))).
thf(article_46_47_p2_article_49_1__const_type,type,(article_46_47_p2_article_49_1__const:($i))).
thf(justification_2__const_type,type,(justification_2__const:($i))).
thf(first_processing_time__const_type,type,(first_processing_time__const:($i))).
thf(controller__const_type,type,(controller__const:($i))).
thf(withdraw_consent_etc__const_type,type,(withdraw_consent_etc__const:($i))).
thf(purpose_2__const_type,type,(purpose_2__const:($i))).
thf(justification__const_type,type,(justification__const:($i))).
thf(second_processing_time__const_type,type,(second_processing_time__const:($i))).
thf(processor__const_type,type,(processor__const:($i))).
% predicates
thf(personal_data_processed_type,type,(personal_data_processed:($i>$i>$i>$i>$i>(mworld>$o)))).
thf(communicate_within_time_type,type,(communicate_within_time:($i>$i>$i>$i>$i>(mworld>$o)))).
thf(controller_type,type,(controller:($i>$i>(mworld>$o)))).
thf(representive_type,type,(representive:($i>$i>(mworld>$o)))).
thf(recipients_personal_data_type,type,(recipients_personal_data:($i>$i>(mworld>$o)))).
thf(transfer_relates_to_type,type,(transfer_relates_to:($i>$i>$i>$i>(mworld>$o)))).
thf(data_protection_officer_type,type,(data_protection_officer:($i>$i>(mworld>$o)))).
thf(justification_based_type,type,(justification_based:($i>$i>(mworld>$o)))).
thf(different_from_type,type,(different_from:($i>$i>(mworld>$o)))).
thf(data_subject_type,type,(data_subject:($i>(mworld>$o)))).
thf(processor_type,type,(processor:($i>(mworld>$o)))).
thf(collected_at_type,type,(collected_at:($i>$i>(mworld>$o)))).
thf(personal_data_processed_at_time_type,type,(personal_data_processed_at_time:($i>$i>$i>$i>(mworld>$o)))).
thf(nominate_type,type,(nominate:($i>$i>(mworld>$o)))).
thf(communicate_before_time_type,type,(communicate_before_time:($i>$i>$i>$i>(mworld>$o)))).
thf(is_obliged_to_give_type,type,(is_obliged_to_give:($i>$i>$i>(mworld>$o)))).
thf(personal_data_type,type,(personal_data:($i>$i>(mworld>$o)))).
thf(type_provision_type,type,(type_provision:($i>$i>$i>(mworld>$o)))).
thf(earlier_type,type,(earlier:($i>$i>(mworld>$o)))).
thf(stored_during_type,type,(stored_during:($i>$i>$o))).
thf(intent_transfer_data_to_type,type,(intent_transfer_data_to:($i>$i>$i>(mworld>$o)))).
thf(already_has_type,type,(already_has:($i>$i>(mworld>$o)))).
thf(communicate_at_time_type,type,(communicate_at_time:($i>$i>$i>$i>(mworld>$o)))).
thf(consequence_refusing_to_give_type,type,(consequence_refusing_to_give:($i>$i>$i>(mworld>$o)))).
% functions
thf(criteria_storing_data_type,type,(criteria_storing_data:($i>$i>$i))).
thf(legitimate_interest_third_party_or_type,type,(legitimate_interest_third_party_or:($i>$i>$i))).
thf(legal_basis_type,type,(legal_basis:($i>$i>$i))).
thf(existence_right_of_type,type,(existence_right_of:($i>$i>$i>$i>$i))).
thf(contact_details_type,type,(contact_details:($i>$i))).
thf(information_of_transfer_type,type,(information_of_transfer:($i>$i>$i>$i>$i))).
thf(appropriate_safeguards_type,type,(appropriate_safeguards:($i>$i>$i>$i>$i))).
thf(stored_during_type,type,(stored_during:($i>$i>$i))).
thf(existence_ai_type,type,(existence_ai:($i>$i>$i))).
thf(purpose_of_processing_type,type,(purpose_of_processing:($i>$i>$i))).
thf(info_obliged_give_data_type,type,(info_obliged_give_data:($i>$i>$i))).
thf(recepients_of_data_type,type,(recepients_of_data:($i>$i))).
thf(info_type,type,(info:($i>$i))).
% converted problem
%----------------------------------------------------------------------------
% File     : Name : QMLTP v1.1
% Domain   : GDPR
% Problem  : ?
% Version  : ?
% English  : Is it compliant to have in the policy: We will update you about the purpose of the further processing before the time of processing
%
% Source   :
% Names    :
% Status   : Theorem
% Rating   : 0.00  v1.1
%            domain condition for all modalities: const
%            term conditions  for all terms:
%            designation: rigid
%
% Comments :
%--------------------------------------------------------------------------
thf(axiom_0,axiom,( mactual @ (((mforall_const__o__d_i_c_@(^ [ Subject__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Controller__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Processor__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Data__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Time__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Justification__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Purpose__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Time0__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Representive__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ DPO__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ LegalBasis__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Party__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Recipients__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Country__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Information__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ SafeGuards__var : ($i) ] : ((mand@((mand@((mand@((mand@((mand@((mand@((mand@((mand@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(contact_details@Controller__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(contact_details@Controller__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(contact_details@Controller__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var)))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(contact_details@Representive__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((representive@Controller__var@Representive__var))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(contact_details@Representive__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((representive@Controller__var@Representive__var))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(contact_details@Representive__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((representive@Controller__var@Representive__var)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(contact_details@DPO__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((data_protection_officer@DPO__var@Data__var))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(contact_details@DPO__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((data_protection_officer@DPO__var@Data__var))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(contact_details@DPO__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((data_protection_officer@DPO__var@Data__var)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(purpose_of_processing@Purpose__var@Data__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(purpose_of_processing@Purpose__var@Data__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(purpose_of_processing@Purpose__var@Data__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(legal_basis@LegalBasis__var@Purpose__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(legal_basis@LegalBasis__var@Purpose__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(legal_basis@LegalBasis__var@Purpose__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(legitimate_interest_third_party_or@Party__var@Controller__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((justification_based@Justification__var@article_6_1__const))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(legitimate_interest_third_party_or@Party__var@Controller__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((justification_based@Justification__var@article_6_1__const))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(legitimate_interest_third_party_or@Party__var@Controller__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((justification_based@Justification__var@article_6_1__const)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(recepients_of_data@Recipients__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((recipients_personal_data@Recipients__var@Data__var))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(recepients_of_data@Recipients__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((recipients_personal_data@Recipients__var@Data__var))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(recepients_of_data@Recipients__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((recipients_personal_data@Recipients__var@Data__var)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((intent_transfer_data_to@Controller__var@Data__var@Country__var))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((intent_transfer_data_to@Controller__var@Data__var@Country__var))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((intent_transfer_data_to@Controller__var@Data__var@Country__var)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((transfer_relates_to@Controller__var@Data__var@Country__var@article_46_47_p2_article_49_1__const))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((transfer_relates_to@Controller__var@Data__var@Country__var@article_46_47_p2_article_49_1__const))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((transfer_relates_to@Controller__var@Data__var@Country__var@article_46_47_p2_article_49_1__const)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) )).
thf(axiom_1,axiom,( mactual @ (((mforall_const__o__d_i_c_@(^ [ Subject__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Data__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Period__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Processor__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Controller__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Time__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Justification__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Purpose__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Time0__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Criteria__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ ProvisionType__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ IsObliged__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Consequences__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Algorithm__var : ($i) ] : ((mand@((mand@((mand@((mand@((mand@((mand@((mand@((mand@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(stored_during@Data__var@Period__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(stored_during@Data__var@Period__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(stored_during@Data__var@Period__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var)))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mnot @((stored_during@Data__var@Period__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mnot @((stored_during@Data__var@Period__var))))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mnot @((stored_during@Data__var@Period__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((type_provision@Subject__var@Data__var@ProvisionType__var))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((type_provision@Subject__var@Data__var@ProvisionType__var))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((type_provision@Subject__var@Data__var@ProvisionType__var)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((is_obliged_to_give@Subject__var@Data__var@IsObliged__var))@((consequence_refusing_to_give@Subject__var@Data__var@Consequences__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((is_obliged_to_give@Subject__var@Data__var@IsObliged__var))@((consequence_refusing_to_give@Subject__var@Data__var@Consequences__var))))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((is_obliged_to_give@Subject__var@Data__var@IsObliged__var))@((consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var)))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var)))))@((mbox_int_1@(mnot @((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) )).
thf(axiom_2,axiom,( mactual @ (((mforall_const__o__d_i_c_@(^ [ Subject__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Purpose2__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Data__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Time__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Time2__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Processor2__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Justification2__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Purpose__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Controller__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Processor__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Justification__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Time0__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Period__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Criteria__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ ProvisionType__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ IsObliged__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Consequences__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Algorithm__var : ($i) ] : ((mand@((mand@((mand@((mand@((mand@((mand@((mand@((mand@((mand@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(purpose_of_processing@Purpose2__var@Data__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(purpose_of_processing@Purpose2__var@Data__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(purpose_of_processing@Purpose2__var@Data__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var)))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(stored_during@Data__var@Period__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(stored_during@Data__var@Period__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(stored_during@Data__var@Period__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mnot @((stored_during@Data__var@Period__var))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mnot @((stored_during@Data__var@Period__var))))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mnot @((stored_during@Data__var@Period__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((type_provision@Subject__var@Data__var@ProvisionType__var))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((type_provision@Subject__var@Data__var@ProvisionType__var))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((type_provision@Subject__var@Data__var@ProvisionType__var)))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(info@ProvisionType__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))))))))))))))@(((mand@((mimplies@((mand@((mand@((mnot @((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((is_obliged_to_give@Subject__var@Data__var@IsObliged__var))@((consequence_refusing_to_give@Subject__var@Data__var@Consequences__var))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mand@((mnot @((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((is_obliged_to_give@Subject__var@Data__var@IsObliged__var))@((consequence_refusing_to_give@Subject__var@Data__var@Consequences__var))))))))@((mbox_int_1@(mnot @((mand@((mand@((mnot @((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((is_obliged_to_give@Subject__var@Data__var@IsObliged__var))@((consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))))))))))))))@(((mand@((mimplies@((mand@((mnot @((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var))))))))))@((mimplies@((mbox_int_0@((mand@((mbox_int_0@((mand@((mnot @((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var))))))))))@((mbox_int_1@(mnot @((mand@((mnot @((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var)))))@((mand@((mand@((mand@((mand@((mand@((earlier@Time__var@Time2__var))@((personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))))@((different_from@Purpose2__var@Purpose__var))))@((nominate@Controller__var@Processor2__var))))@((processor@Processor2__var))))@((mand@((mand@((mand@((mand@((mand@((mand@((processor@Processor__var))@((nominate@Controller__var@Processor__var))))@((personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))))@((personal_data@Data__var@Subject__var))))@((collected_at@Data__var@Time0__var))))@((data_subject@Subject__var))))@((controller@Controller__var@Data__var)))))))))))))))@((mbox_int_0@((mand@((mbox_int_0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var)))))@((mbox_int_1@(mnot @((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) )).
thf(axiom_3,axiom,( mactual @ ((controller@controller__const@data__const)) )).
thf(axiom_4,axiom,( mactual @ ((nominate@controller__const@processor__const)) )).
thf(axiom_5,axiom,( mactual @ ((processor@processor__const)) )).
thf(axiom_6,axiom,( mactual @ ((personal_data_processed@processor__const@data__const@second_processing_time__const@justification__const@purpose__const)) )).
thf(axiom_7,axiom,( mactual @ ((personal_data@data__const@subject__const)) )).
thf(axiom_8,axiom,( mactual @ ((data_subject@subject__const)) )).
thf(axiom_9,axiom,( mactual @ ((collected_at@data__const@collection_time__const)) )).
thf(axiom_10,axiom,( mactual @ ((nominate@controller__const@processor_2__const)) )).
thf(axiom_11,axiom,( mactual @ ((processor@processor_2__const)) )).
thf(axiom_12,axiom,( mactual @ ((personal_data_processed@processor_2__const@data__const@first_processing_time__const@justification_2__const@purpose_2__const)) )).
thf(axiom_13,axiom,( mactual @ ((earlier@first_processing_time__const@second_processing_time__const)) )).
thf(axiom_14,axiom,( mactual @ ((different_from@purpose__const@purpose_2__const)) )).
thf(axiom_15,axiom,( mactual @ (((mforall_const__o__d_i_c_@(^ [ Controllerlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Subjectlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Zlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Actionlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Ylog1__var : ($i) ] : ((mimplies@((mand@(((mand@((mdia_int_0@((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))@((mdia_int_1@(mnot @((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))))))@((earlier@Ylog1__var@Zlog1__var))))@(((mand@((mdia_int_0@((communicate_within_time@Ylog1__var@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))@((mdia_int_1@(mnot @((communicate_within_time@Ylog1__var@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var)))))))))))))))))))))))))) )).
thf(axiom_16,axiom,( mactual @ (((mforall_const__o__d_i_c_@(^ [ Controllerlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Subjectlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Zlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Actionlog1__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Ylog1__var : ($i) ] : ((mimplies@((mand@(((mand@((mdia_int_0@((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))@((mdia_int_1@(mnot @((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))))))@((earlier@Ylog1__var@Zlog1__var))))@(((mand@((mdia_int_0@((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Ylog1__var@Actionlog1__var))))@((mdia_int_1@(mnot @((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Ylog1__var@Actionlog1__var)))))))))))))))))))))))))) )).
thf(axiom_17,axiom,( mactual @ ((earlier@collection_time__const@first_processing_time__const)) )).
thf(axiom_18,axiom,( mactual @ (((mforall_const__o__d_i_c_@(^ [ X__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Y__var : ($i) ] : ((mforall_const__o__d_i_c_@(^ [ Z__var : ($i) ] : ((mimplies@((mand@((earlier@X__var@Y__var))@((earlier@Y__var@Z__var))))@((earlier@X__var@Z__var)))))))))))))) )).
thf(axiom_19,axiom,( mactual @ ((mnot @((already_has@subject__const@(purpose_of_processing@purpose__const@data__const))))) )).
thf(con,conjecture,( mactual @ (((mand@((mdia_int_0@((communicate_before_time@controller__const@subject__const@second_processing_time__const@(purpose_of_processing@purpose__const@data__const)))))@((mdia_int_1@(mnot @((communicate_before_time@controller__const@subject__const@second_processing_time__const@(purpose_of_processing@purpose__const@data__const))))))))) )).


% -------------------------------------------------------------------------
% old problem
% -------------------------------------------------------------------------

%% semantics
%thf(semantics,logic,($modal:=[$constants:=$rigid,$quantification:=$constant,$consequence:=$local,$modalities:=[$box_int@0:=$modal_system_D,$box_int@1:=$modal_system_D]])).
%% propositions
%% individual constants
%thf(article_6_1_article_9_2_a__const_type,type,(article_6_1_article_9_2_a__const:($i))).
%thf(purpose__const_type,type,(purpose__const:($i))).
%thf(lodge_complaint__const_type,type,(lodge_complaint__const:($i))).
%thf(access_rectification_etc__const_type,type,(access_rectification_etc__const:($i))).
%thf(data__const_type,type,(data__const:($i))).
%thf(collection_time__const_type,type,(collection_time__const:($i))).
%thf(processor_2__const_type,type,(processor_2__const:($i))).
%thf(subject__const_type,type,(subject__const:($i))).
%thf(article_6_1__const_type,type,(article_6_1__const:($i))).
%thf(article_46_47_p2_article_49_1__const_type,type,(article_46_47_p2_article_49_1__const:($i))).
%thf(justification_2__const_type,type,(justification_2__const:($i))).
%thf(first_processing_time__const_type,type,(first_processing_time__const:($i))).
%thf(controller__const_type,type,(controller__const:($i))).
%thf(withdraw_consent_etc__const_type,type,(withdraw_consent_etc__const:($i))).
%thf(purpose_2__const_type,type,(purpose_2__const:($i))).
%thf(justification__const_type,type,(justification__const:($i))).
%thf(second_processing_time__const_type,type,(second_processing_time__const:($i))).
%thf(processor__const_type,type,(processor__const:($i))).
%% predicates
%thf(personal_data_processed_type,type,(personal_data_processed:($i>$i>$i>$i>$i>$o))).
%thf(communicate_within_time_type,type,(communicate_within_time:($i>$i>$i>$i>$i>$o))).
%thf(controller_type,type,(controller:($i>$i>$o))).
%thf(representive_type,type,(representive:($i>$i>$o))).
%thf(recipients_personal_data_type,type,(recipients_personal_data:($i>$i>$o))).
%thf(transfer_relates_to_type,type,(transfer_relates_to:($i>$i>$i>$i>$o))).
%thf(data_protection_officer_type,type,(data_protection_officer:($i>$i>$o))).
%thf(justification_based_type,type,(justification_based:($i>$i>$o))).
%thf(different_from_type,type,(different_from:($i>$i>$o))).
%thf(data_subject_type,type,(data_subject:($i>$o))).
%thf(processor_type,type,(processor:($i>$o))).
%thf(collected_at_type,type,(collected_at:($i>$i>$o))).
%thf(personal_data_processed_at_time_type,type,(personal_data_processed_at_time:($i>$i>$i>$i>$o))).
%thf(nominate_type,type,(nominate:($i>$i>$o))).
%thf(communicate_before_time_type,type,(communicate_before_time:($i>$i>$i>$i>$o))).
%thf(is_obliged_to_give_type,type,(is_obliged_to_give:($i>$i>$i>$o))).
%thf(personal_data_type,type,(personal_data:($i>$i>$o))).
%thf(type_provision_type,type,(type_provision:($i>$i>$i>$o))).
%thf(earlier_type,type,(earlier:($i>$i>$o))).
%thf(stored_during_type,type,(stored_during:($i>$i>$o))).
%thf(intent_transfer_data_to_type,type,(intent_transfer_data_to:($i>$i>$i>$o))).
%thf(already_has_type,type,(already_has:($i>$i>$o))).
%thf(communicate_at_time_type,type,(communicate_at_time:($i>$i>$i>$i>$o))).
%thf(consequence_refusing_to_give_type,type,(consequence_refusing_to_give:($i>$i>$i>$o))).
%% functions
%thf(criteria_storing_data_type,type,(criteria_storing_data:($i>$i>$i))).
%thf(legitimate_interest_third_party_or_type,type,(legitimate_interest_third_party_or:($i>$i>$i))).
%thf(legal_basis_type,type,(legal_basis:($i>$i>$i))).
%thf(existence_right_of_type,type,(existence_right_of:($i>$i>$i>$i>$i))).
%thf(contact_details_type,type,(contact_details:($i>$i))).
%thf(information_of_transfer_type,type,(information_of_transfer:($i>$i>$i>$i>$i))).
%thf(appropriate_safeguards_type,type,(appropriate_safeguards:($i>$i>$i>$i>$i))).
%thf(stored_during_type,type,(stored_during:($i>$i>$i))).
%thf(existence_ai_type,type,(existence_ai:($i>$i>$i))).
%thf(purpose_of_processing_type,type,(purpose_of_processing:($i>$i>$i))).
%thf(info_obliged_give_data_type,type,(info_obliged_give_data:($i>$i>$i))).
%thf(recepients_of_data_type,type,(recepients_of_data:($i>$i))).
%thf(info_type,type,(info:($i>$i))).
%% converted problem
%%----------------------------------------------------------------------------
%% File     : Name : QMLTP v1.1
%% Domain   : GDPR
%% Problem  : ?
%% Version  : ?
%% English  : Is it compliant to have in the policy: We will update you about the purpose of the further processing before the time of processing
%%
%% Source   :
%% Names    :
%% Status   : Theorem
%% Rating   : 0.00  v1.1
%%            domain condition for all modalities: const
%%            term conditions  for all terms:
%%            designation: rigid
%%
%% Comments :
%%--------------------------------------------------------------------------
%thf(axiom_0,axiom,(![Subject__var:$i,Controller__var:$i,Processor__var:$i,Data__var:$i,Time__var:$i,Justification__var:$i,Purpose__var:$i,Time0__var:$i,Representive__var:$i,DPO__var:$i,LegalBasis__var:$i,Party__var:$i,Recipients__var:$i,Country__var:$i,Information__var:$i,SafeGuards__var:$i]:(((((((((((((~((already_has@Subject__var@(contact_details@Controller__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(contact_details@Controller__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(contact_details@Controller__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Controller__var)))))))))))&((((((~((already_has@Subject__var@(contact_details@Representive__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(representive@Controller__var@Representive__var))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(contact_details@Representive__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(representive@Controller__var@Representive__var))))&($box_int@1@(~((((~((already_has@Subject__var@(contact_details@Representive__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(representive@Controller__var@Representive__var))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@Representive__var))))))))))))&((((((~((already_has@Subject__var@(contact_details@DPO__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(data_protection_officer@DPO__var@Data__var))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(contact_details@DPO__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(data_protection_officer@DPO__var@Data__var))))&($box_int@1@(~((((~((already_has@Subject__var@(contact_details@DPO__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(data_protection_officer@DPO__var@Data__var))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(contact_details@DPO__var))))))))))))&(((((~((already_has@Subject__var@(purpose_of_processing@Purpose__var@Data__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(purpose_of_processing@Purpose__var@Data__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(purpose_of_processing@Purpose__var@Data__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(purpose_of_processing@Purpose__var@Data__var))))))))))))&(((((~((already_has@Subject__var@(legal_basis@LegalBasis__var@Purpose__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(legal_basis@LegalBasis__var@Purpose__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(legal_basis@LegalBasis__var@Purpose__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(legal_basis@LegalBasis__var@Purpose__var))))))))))))&((((((~((already_has@Subject__var@(legitimate_interest_third_party_or@Party__var@Controller__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(justification_based@Justification__var@article_6_1__const))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(legitimate_interest_third_party_or@Party__var@Controller__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(justification_based@Justification__var@article_6_1__const))))&($box_int@1@(~((((~((already_has@Subject__var@(legitimate_interest_third_party_or@Party__var@Controller__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(justification_based@Justification__var@article_6_1__const))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(legitimate_interest_third_party_or@Party__var@Controller__var))))))))))))&((((((~((already_has@Subject__var@(recepients_of_data@Recipients__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(recipients_personal_data@Recipients__var@Data__var))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(recepients_of_data@Recipients__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(recipients_personal_data@Recipients__var@Data__var))))&($box_int@1@(~((((~((already_has@Subject__var@(recepients_of_data@Recipients__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(recipients_personal_data@Recipients__var@Data__var))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(recepients_of_data@Recipients__var))))))))))))&((((((~((already_has@Subject__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(intent_transfer_data_to@Controller__var@Data__var@Country__var))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(intent_transfer_data_to@Controller__var@Data__var@Country__var))))&($box_int@1@(~((((~((already_has@Subject__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(intent_transfer_data_to@Controller__var@Data__var@Country__var))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(information_of_transfer@Controller__var@Data__var@Country__var@Information__var))))))))))))&((((((~((already_has@Subject__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(transfer_relates_to@Controller__var@Data__var@Country__var@article_46_47_p2_article_49_1__const))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(transfer_relates_to@Controller__var@Data__var@Country__var@article_46_47_p2_article_49_1__const))))&($box_int@1@(~((((~((already_has@Subject__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(transfer_relates_to@Controller__var@Data__var@Country__var@article_46_47_p2_article_49_1__const))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(appropriate_safeguards@Controller__var@Data__var@Country__var@SafeGuards__var)))))))))))))).
%thf(axiom_1,axiom,(![Subject__var:$i,Data__var:$i,Period__var:$i,Processor__var:$i,Controller__var:$i,Time__var:$i,Justification__var:$i,Purpose__var:$i,Time0__var:$i,Criteria__var:$i,ProvisionType__var:$i,IsObliged__var:$i,Consequences__var:$i,Algorithm__var:$i]:(((((((((((((~((already_has@Subject__var@(stored_during@Data__var@Period__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(stored_during@Data__var@Period__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(stored_during@Data__var@Period__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(stored_during@Data__var@Period__var)))))))))))&((((((~((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(~((stored_during@Data__var@Period__var))))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(~((stored_during@Data__var@Period__var))))))&($box_int@1@(~((((~((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(~((stored_during@Data__var@Period__var))))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(criteria_storing_data@Data__var@Criteria__var))))))))))))&(((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))))))))))&((((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))&($box_int@1@(~((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))))))))))&(((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))))))))))&((((((~((already_has@Subject__var@(info@ProvisionType__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(type_provision@Subject__var@Data__var@ProvisionType__var))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(info@ProvisionType__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(type_provision@Subject__var@Data__var@ProvisionType__var))))&($box_int@1@(~((((~((already_has@Subject__var@(info@ProvisionType__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&(type_provision@Subject__var@Data__var@ProvisionType__var))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))))))))))&(((((~((already_has@Subject__var@(info@ProvisionType__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(info@ProvisionType__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(info@ProvisionType__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(info@ProvisionType__var))))))))))))&((((((~((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&((is_obliged_to_give@Subject__var@Data__var@IsObliged__var)&(consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&((is_obliged_to_give@Subject__var@Data__var@IsObliged__var)&(consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))))&($box_int@1@(~((((~((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))&((is_obliged_to_give@Subject__var@Data__var@IsObliged__var)&(consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))))))))))&(((((~((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))=>(($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))&($box_int@1@(~(((~((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var))))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var)))))))))=>($box_int@0@((($box_int@0@((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var))))&($box_int@1@(~((communicate_at_time@Controller__var@Subject__var@Time0__var@(existence_ai@Data__var@Algorithm__var)))))))))))))).
%thf(axiom_2,axiom,(![Subject__var:$i,Purpose2__var:$i,Data__var:$i,Time__var:$i,Time2__var:$i,Processor2__var:$i,Justification2__var:$i,Purpose__var:$i,Controller__var:$i,Processor__var:$i,Justification__var:$i,Time0__var:$i,Period__var:$i,Criteria__var:$i,ProvisionType__var:$i,IsObliged__var:$i,Consequences__var:$i,Algorithm__var:$i]:((((((((((((((~((already_has@Subject__var@(purpose_of_processing@Purpose2__var@Data__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(purpose_of_processing@Purpose2__var@Data__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))&($box_int@1@(~(((~((already_has@Subject__var@(purpose_of_processing@Purpose2__var@Data__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(purpose_of_processing@Purpose2__var@Data__var)))))))))))&(((((~((already_has@Subject__var@(stored_during@Data__var@Period__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(stored_during@Data__var@Period__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))&($box_int@1@(~(((~((already_has@Subject__var@(stored_during@Data__var@Period__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(stored_during@Data__var@Period__var))))))))))))&((((((~((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(~((stored_during@Data__var@Period__var))))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(~((stored_during@Data__var@Period__var))))))&($box_int@1@(~((((~((already_has@Subject__var@(criteria_storing_data@Data__var@Criteria__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(~((stored_during@Data__var@Period__var))))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(criteria_storing_data@Data__var@Criteria__var))))))))))))&(((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))&($box_int@1@(~(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@access_rectification_etc__const))))))))))))&((((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))&($box_int@1@(~((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(personal_data_processed_at_time@Processor__var@Data__var@Time__var@article_6_1_article_9_2_a__const))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@withdraw_consent_etc__const))))))))))))&(((((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))&($box_int@1@(~(((~((already_has@Subject__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_right_of@Controller__var@Subject__var@Data__var@lodge_complaint__const))))))))))))&((((((~((already_has@Subject__var@(info@ProvisionType__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(type_provision@Subject__var@Data__var@ProvisionType__var))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(info@ProvisionType__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(type_provision@Subject__var@Data__var@ProvisionType__var))))&($box_int@1@(~((((~((already_has@Subject__var@(info@ProvisionType__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&(type_provision@Subject__var@Data__var@ProvisionType__var))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))))))))))&(((((~((already_has@Subject__var@(info@ProvisionType__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(info@ProvisionType__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))&($box_int@1@(~(((~((already_has@Subject__var@(info@ProvisionType__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(info@ProvisionType__var))))))))))))&((((((~((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&((is_obliged_to_give@Subject__var@Data__var@IsObliged__var)&(consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var)))))))&(($box_int@0@((($box_int@0@((((~((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&((is_obliged_to_give@Subject__var@Data__var@IsObliged__var)&(consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))))&($box_int@1@(~((((~((already_has@Subject__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))&((is_obliged_to_give@Subject__var@Data__var@IsObliged__var)&(consequence_refusing_to_give@Subject__var@Data__var@Consequences__var)))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(info_obliged_give_data@IsObliged__var@Consequences__var))))))))))))&(((((~((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))=>(($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var)))))))&(($box_int@0@((($box_int@0@(((~((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))&($box_int@1@(~(((~((already_has@Subject__var@(existence_ai@Data__var@Algorithm__var))))&((((((earlier@Time__var@Time2__var)&(personal_data_processed@Processor2__var@Data__var@Time2__var@Justification2__var@Purpose2__var))&(different_from@Purpose2__var@Purpose__var))&(nominate@Controller__var@Processor2__var))&(processor@Processor2__var))&(((((((processor@Processor__var)&(nominate@Controller__var@Processor__var))&(personal_data_processed@Processor__var@Data__var@Time__var@Justification__var@Purpose__var))&(personal_data@Data__var@Subject__var))&(collected_at@Data__var@Time0__var))&(data_subject@Subject__var))&(controller@Controller__var@Data__var))))))))))=>($box_int@0@((($box_int@0@((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var))))&($box_int@1@(~((communicate_before_time@Controller__var@Subject__var@Time2__var@(existence_ai@Data__var@Algorithm__var)))))))))))))).
%thf(axiom_3,axiom,(controller@controller__const@data__const)).
%thf(axiom_4,axiom,(nominate@controller__const@processor__const)).
%thf(axiom_5,axiom,(processor@processor__const)).
%thf(axiom_6,axiom,(personal_data_processed@processor__const@data__const@second_processing_time__const@justification__const@purpose__const)).
%thf(axiom_7,axiom,(personal_data@data__const@subject__const)).
%thf(axiom_8,axiom,(data_subject@subject__const)).
%thf(axiom_9,axiom,(collected_at@data__const@collection_time__const)).
%thf(axiom_10,axiom,(nominate@controller__const@processor_2__const)).
%thf(axiom_11,axiom,(processor@processor_2__const)).
%thf(axiom_12,axiom,(personal_data_processed@processor_2__const@data__const@first_processing_time__const@justification_2__const@purpose_2__const)).
%thf(axiom_13,axiom,(earlier@first_processing_time__const@second_processing_time__const)).
%thf(axiom_14,axiom,(different_from@purpose__const@purpose_2__const)).
%thf(axiom_15,axiom,(![Controllerlog1__var:$i,Subjectlog1__var:$i,Zlog1__var:$i,Actionlog1__var:$i,Ylog1__var:$i]:((((($dia_int@0@((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var)))&($dia_int@1@(~((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))))&(earlier@Ylog1__var@Zlog1__var))=>((($dia_int@0@((communicate_within_time@Ylog1__var@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var)))&($dia_int@1@(~((communicate_within_time@Ylog1__var@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))))))).
%thf(axiom_16,axiom,(![Controllerlog1__var:$i,Subjectlog1__var:$i,Zlog1__var:$i,Actionlog1__var:$i,Ylog1__var:$i]:((((($dia_int@0@((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var)))&($dia_int@1@(~((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Zlog1__var@Actionlog1__var))))))&(earlier@Ylog1__var@Zlog1__var))=>((($dia_int@0@((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Ylog1__var@Actionlog1__var)))&($dia_int@1@(~((communicate_before_time@Controllerlog1__var@Subjectlog1__var@Ylog1__var@Actionlog1__var))))))))).
%thf(axiom_17,axiom,(earlier@collection_time__const@first_processing_time__const)).
%thf(axiom_18,axiom,(![X__var:$i,Y__var:$i,Z__var:$i]:(((earlier@X__var@Y__var)&(earlier@Y__var@Z__var))=>(earlier@X__var@Z__var)))).
%thf(axiom_19,axiom,(~((already_has@subject__const@(purpose_of_processing@purpose__const@data__const))))).
%thf(con,conjecture,((($dia_int@0@((communicate_before_time@controller__const@subject__const@second_processing_time__const@(purpose_of_processing@purpose__const@data__const))))&($dia_int@1@(~((communicate_before_time@controller__const@subject__const@second_processing_time__const@(purpose_of_processing@purpose__const@data__const)))))))).

